
#ifndef __FSOBASICS_H__
#define __FSOBASICS_H__

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <sys/types.h>

G_BEGIN_DECLS


#define FSO_FRAMEWORK_TYPE_LOGGER (fso_framework_logger_get_type ())
#define FSO_FRAMEWORK_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_LOGGER, FsoFrameworkLogger))
#define FSO_FRAMEWORK_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_LOGGER))
#define FSO_FRAMEWORK_LOGGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FSO_FRAMEWORK_TYPE_LOGGER, FsoFrameworkLoggerIface))

typedef struct _FsoFrameworkLogger FsoFrameworkLogger;
typedef struct _FsoFrameworkLoggerIface FsoFrameworkLoggerIface;

#define FSO_FRAMEWORK_TYPE_SMART_KEY_FILE (fso_framework_smart_key_file_get_type ())
#define FSO_FRAMEWORK_SMART_KEY_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE, FsoFrameworkSmartKeyFile))
#define FSO_FRAMEWORK_SMART_KEY_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE, FsoFrameworkSmartKeyFileClass))
#define FSO_FRAMEWORK_IS_SMART_KEY_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE))
#define FSO_FRAMEWORK_IS_SMART_KEY_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE))
#define FSO_FRAMEWORK_SMART_KEY_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE, FsoFrameworkSmartKeyFileClass))

typedef struct _FsoFrameworkSmartKeyFile FsoFrameworkSmartKeyFile;
typedef struct _FsoFrameworkSmartKeyFileClass FsoFrameworkSmartKeyFileClass;

#define FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER (fso_framework_abstract_logger_get_type ())
#define FSO_FRAMEWORK_ABSTRACT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER, FsoFrameworkAbstractLogger))
#define FSO_FRAMEWORK_ABSTRACT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER, FsoFrameworkAbstractLoggerClass))
#define FSO_FRAMEWORK_IS_ABSTRACT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER))
#define FSO_FRAMEWORK_IS_ABSTRACT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER))
#define FSO_FRAMEWORK_ABSTRACT_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER, FsoFrameworkAbstractLoggerClass))

typedef struct _FsoFrameworkAbstractLogger FsoFrameworkAbstractLogger;
typedef struct _FsoFrameworkAbstractLoggerClass FsoFrameworkAbstractLoggerClass;
typedef struct _FsoFrameworkAbstractLoggerPrivate FsoFrameworkAbstractLoggerPrivate;

#define FSO_FRAMEWORK_TYPE_NULL_LOGGER (fso_framework_null_logger_get_type ())
#define FSO_FRAMEWORK_NULL_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_NULL_LOGGER, FsoFrameworkNullLogger))
#define FSO_FRAMEWORK_NULL_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_NULL_LOGGER, FsoFrameworkNullLoggerClass))
#define FSO_FRAMEWORK_IS_NULL_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_NULL_LOGGER))
#define FSO_FRAMEWORK_IS_NULL_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_NULL_LOGGER))
#define FSO_FRAMEWORK_NULL_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_NULL_LOGGER, FsoFrameworkNullLoggerClass))

typedef struct _FsoFrameworkNullLogger FsoFrameworkNullLogger;
typedef struct _FsoFrameworkNullLoggerClass FsoFrameworkNullLoggerClass;
typedef struct _FsoFrameworkNullLoggerPrivate FsoFrameworkNullLoggerPrivate;

#define FSO_FRAMEWORK_TYPE_FILE_LOGGER (fso_framework_file_logger_get_type ())
#define FSO_FRAMEWORK_FILE_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_FILE_LOGGER, FsoFrameworkFileLogger))
#define FSO_FRAMEWORK_FILE_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_FILE_LOGGER, FsoFrameworkFileLoggerClass))
#define FSO_FRAMEWORK_IS_FILE_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_FILE_LOGGER))
#define FSO_FRAMEWORK_IS_FILE_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_FILE_LOGGER))
#define FSO_FRAMEWORK_FILE_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_FILE_LOGGER, FsoFrameworkFileLoggerClass))

typedef struct _FsoFrameworkFileLogger FsoFrameworkFileLogger;
typedef struct _FsoFrameworkFileLoggerClass FsoFrameworkFileLoggerClass;
typedef struct _FsoFrameworkFileLoggerPrivate FsoFrameworkFileLoggerPrivate;

#define FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER (fso_framework_syslog_logger_get_type ())
#define FSO_FRAMEWORK_SYSLOG_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER, FsoFrameworkSyslogLogger))
#define FSO_FRAMEWORK_SYSLOG_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER, FsoFrameworkSyslogLoggerClass))
#define FSO_FRAMEWORK_IS_SYSLOG_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER))
#define FSO_FRAMEWORK_IS_SYSLOG_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER))
#define FSO_FRAMEWORK_SYSLOG_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER, FsoFrameworkSyslogLoggerClass))

typedef struct _FsoFrameworkSyslogLogger FsoFrameworkSyslogLogger;
typedef struct _FsoFrameworkSyslogLoggerClass FsoFrameworkSyslogLoggerClass;
typedef struct _FsoFrameworkSyslogLoggerPrivate FsoFrameworkSyslogLoggerPrivate;
typedef struct _FsoFrameworkSmartKeyFilePrivate FsoFrameworkSmartKeyFilePrivate;

#define FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION (fso_framework_smart_key_file_section_get_type ())
#define FSO_FRAMEWORK_SMART_KEY_FILE_SECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION, FsoFrameworkSmartKeyFileSection))
#define FSO_FRAMEWORK_SMART_KEY_FILE_SECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION, FsoFrameworkSmartKeyFileSectionClass))
#define FSO_FRAMEWORK_IS_SMART_KEY_FILE_SECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION))
#define FSO_FRAMEWORK_IS_SMART_KEY_FILE_SECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION))
#define FSO_FRAMEWORK_SMART_KEY_FILE_SECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION, FsoFrameworkSmartKeyFileSectionClass))

typedef struct _FsoFrameworkSmartKeyFileSection FsoFrameworkSmartKeyFileSection;
typedef struct _FsoFrameworkSmartKeyFileSectionClass FsoFrameworkSmartKeyFileSectionClass;
typedef struct _FsoFrameworkSmartKeyFileSectionPrivate FsoFrameworkSmartKeyFileSectionPrivate;
typedef struct _FsoFrameworkAsyncEventFd FsoFrameworkAsyncEventFd;

/**
 * Delegates
 */
typedef char* (*ReprDelegate) (void* user_data);
/**
 * Logger
 */
struct _FsoFrameworkLoggerIface {
	GTypeInterface parent_iface;
	void (*setLevel) (FsoFrameworkLogger* self, GLogLevelFlags level);
	void (*setDestination) (FsoFrameworkLogger* self, const char* destination);
	void (*setReprDelegate) (FsoFrameworkLogger* self, ReprDelegate repr, void* repr_target);
	GLogLevelFlags (*getLevel) (FsoFrameworkLogger* self);
	char* (*getDestination) (FsoFrameworkLogger* self);
	void (*debug) (FsoFrameworkLogger* self, const char* message);
	void (*info) (FsoFrameworkLogger* self, const char* message);
	void (*warning) (FsoFrameworkLogger* self, const char* message);
	void (*error) (FsoFrameworkLogger* self, const char* message);
	void (*critical) (FsoFrameworkLogger* self, const char* message);
};

/**
 * AbstractLogger
 */
struct _FsoFrameworkAbstractLogger {
	GObject parent_instance;
	FsoFrameworkAbstractLoggerPrivate * priv;
	guint level;
	char* domain;
	char* destination;
	ReprDelegate reprdelegate;
	gpointer reprdelegate_target;
};

struct _FsoFrameworkAbstractLoggerClass {
	GObjectClass parent_class;
	void (*write) (FsoFrameworkAbstractLogger* self, const char* message);
	char* (*format) (FsoFrameworkAbstractLogger* self, const char* message, const char* level);
};

/**
 * NullLogger
 */
struct _FsoFrameworkNullLogger {
	FsoFrameworkAbstractLogger parent_instance;
	FsoFrameworkNullLoggerPrivate * priv;
};

struct _FsoFrameworkNullLoggerClass {
	FsoFrameworkAbstractLoggerClass parent_class;
};

/**
 * FileLogger
 */
struct _FsoFrameworkFileLogger {
	FsoFrameworkAbstractLogger parent_instance;
	FsoFrameworkFileLoggerPrivate * priv;
};

struct _FsoFrameworkFileLoggerClass {
	FsoFrameworkAbstractLoggerClass parent_class;
};

/**
 * SyslogLogger
 */
struct _FsoFrameworkSyslogLogger {
	FsoFrameworkAbstractLogger parent_instance;
	FsoFrameworkSyslogLoggerPrivate * priv;
};

struct _FsoFrameworkSyslogLoggerClass {
	FsoFrameworkAbstractLoggerClass parent_class;
};

/**
 * SmartKeyFile
 */
struct _FsoFrameworkSmartKeyFile {
	GObject parent_instance;
	FsoFrameworkSmartKeyFilePrivate * priv;
};

struct _FsoFrameworkSmartKeyFileClass {
	GObjectClass parent_class;
};

/**
 * SmartKeyFileSection
 */
struct _FsoFrameworkSmartKeyFileSection {
	GObject parent_instance;
	FsoFrameworkSmartKeyFileSectionPrivate * priv;
};

struct _FsoFrameworkSmartKeyFileSectionClass {
	GObjectClass parent_class;
};

struct _FsoFrameworkAsyncEventFd {
	GIOChannel* channel;
	guint watch;
};


GType fso_framework_logger_get_type (void);
void fso_framework_logger_setLevel (FsoFrameworkLogger* self, GLogLevelFlags level);
void fso_framework_logger_setDestination (FsoFrameworkLogger* self, const char* destination);
void fso_framework_logger_setReprDelegate (FsoFrameworkLogger* self, ReprDelegate repr, void* repr_target);
GLogLevelFlags fso_framework_logger_getLevel (FsoFrameworkLogger* self);
char* fso_framework_logger_getDestination (FsoFrameworkLogger* self);
void fso_framework_logger_debug (FsoFrameworkLogger* self, const char* message);
void fso_framework_logger_info (FsoFrameworkLogger* self, const char* message);
void fso_framework_logger_warning (FsoFrameworkLogger* self, const char* message);
void fso_framework_logger_error (FsoFrameworkLogger* self, const char* message);
void fso_framework_logger_critical (FsoFrameworkLogger* self, const char* message);
FsoFrameworkLogger* fso_framework_logger_defaultLogger (void);
GType fso_framework_smart_key_file_get_type (void);
FsoFrameworkLogger* fso_framework_logger_createFromKeyFile (FsoFrameworkSmartKeyFile* smk, const char* domain);
GType fso_framework_abstract_logger_get_type (void);
void fso_framework_abstract_logger_write (FsoFrameworkAbstractLogger* self, const char* message);
char* fso_framework_abstract_logger_format (FsoFrameworkAbstractLogger* self, const char* message, const char* level);
FsoFrameworkAbstractLogger* fso_framework_abstract_logger_new (const char* domain);
FsoFrameworkAbstractLogger* fso_framework_abstract_logger_construct (GType object_type, const char* domain);
char* fso_framework_abstract_logger_levelToString (GLogLevelFlags level);
GLogLevelFlags fso_framework_abstract_logger_stringToLevel (const char* level);
GType fso_framework_null_logger_get_type (void);
FsoFrameworkNullLogger* fso_framework_null_logger_new (const char* domain);
FsoFrameworkNullLogger* fso_framework_null_logger_construct (GType object_type, const char* domain);
GType fso_framework_file_logger_get_type (void);
FsoFrameworkFileLogger* fso_framework_file_logger_new (const char* domain);
FsoFrameworkFileLogger* fso_framework_file_logger_construct (GType object_type, const char* domain);
void fso_framework_file_logger_setFile (FsoFrameworkFileLogger* self, const char* filename, gboolean append);
GType fso_framework_syslog_logger_get_type (void);
FsoFrameworkSyslogLogger* fso_framework_syslog_logger_new (const char* domain);
FsoFrameworkSyslogLogger* fso_framework_syslog_logger_construct (GType object_type, const char* domain);
gboolean fso_framework_smart_key_file_loadFromFile (FsoFrameworkSmartKeyFile* self, const char* filename);
char* fso_framework_smart_key_file_stringValue (FsoFrameworkSmartKeyFile* self, const char* section, const char* key, const char* defaultvalue);
gint fso_framework_smart_key_file_intValue (FsoFrameworkSmartKeyFile* self, const char* section, const char* key, gint defaultvalue);
gboolean fso_framework_smart_key_file_boolValue (FsoFrameworkSmartKeyFile* self, const char* section, const char* key, gboolean defaultvalue);
char** fso_framework_smart_key_file_stringListValue (FsoFrameworkSmartKeyFile* self, const char* section, const char* key, char** defaultvalue, int defaultvalue_length1, int* result_length1);
gboolean fso_framework_smart_key_file_hasSection (FsoFrameworkSmartKeyFile* self, const char* section);
GList* fso_framework_smart_key_file_sectionsWithPrefix (FsoFrameworkSmartKeyFile* self, const char* prefix);
gboolean fso_framework_smart_key_file_hasKey (FsoFrameworkSmartKeyFile* self, const char* section, const char* key);
GList* fso_framework_smart_key_file_keysWithPrefix (FsoFrameworkSmartKeyFile* self, const char* section, const char* prefix);
FsoFrameworkSmartKeyFile* fso_framework_smart_key_file_new (void);
FsoFrameworkSmartKeyFile* fso_framework_smart_key_file_construct (GType object_type);
GType fso_framework_smart_key_file_section_get_type (void);
FsoFrameworkSmartKeyFileSection* fso_framework_smart_key_file_section_openSection (FsoFrameworkSmartKeyFile* kf, const char* section);
gboolean fso_framework_file_handling_isPresent (const char* filename);
char* fso_framework_file_handling_read (const char* filename);
void fso_framework_file_handling_write (const char* contents, const char* filename);
uid_t fso_framework_user_group_handling_uidForUser (const char* user);
gid_t fso_framework_user_group_handling_gidForGroup (const char* group);
gboolean fso_framework_user_group_handling_switchToUserAndGroup (const char* user, const char* group);
char* fso_framework_string_handling_stringListToString (char** list, int list_length1);
char* fso_framework_network_ipv4AddressForInterface (const char* iface);
char* fso_framework_utility_programName (void);
FsoFrameworkAsyncEventFd* fso_framework_async_event_fd_new (guint initvalue, GIOFunc callback, void* callback_target);
FsoFrameworkAsyncEventFd* fso_framework_async_event_fd_new (guint initvalue, GIOFunc callback, void* callback_target);
void fso_framework_async_event_fd_write (FsoFrameworkAsyncEventFd* self, gint count);
guint fso_framework_async_event_fd_read (FsoFrameworkAsyncEventFd* self);


G_END_DECLS

#endif
